diff --git a/ldap/servers/slapd/back-ldbm/ldbm_config.c b/ldap/servers/slapd/back-ldbm/ldbm_config.c
index 67a647540..88bd32a2f 100644
--- a/ldap/servers/slapd/back-ldbm/ldbm_config.c
+++ b/ldap/servers/slapd/back-ldbm/ldbm_config.c
@@ -1482,25 +807,6 @@ ldbm_config_import_cachesize_set(void *arg,
     return LDAP_SUCCESS;
 }
 
-static void *
-ldbm_config_index_buffer_size_get(void *arg __attribute__((unused)))
-{
-    return (void *)import_get_index_buffer_size();
-}
-
-static int
-ldbm_config_index_buffer_size_set(void *arg __attribute__((unused)),
-                                  void *value,
-                                  char *errorbuf __attribute__((unused)),
-                                  int phase __attribute__((unused)),
-                                  int apply)
-{
-    if (apply) {
-        import_configure_index_buffer_size((size_t)value);
-    }
-    return LDAP_SUCCESS;
-}
-
 static void *
 ldbm_config_idl_get_idl_new(void *arg __attribute__((unused)))
 {
@@ -1739,77 +1045,6 @@ ldbm_config_exclude_from_export_get(void *arg)
     return (void *)retstr;
 }
 
-static void *
-ldbm_config_db_tx_max_get(void *arg)
-{
-    struct ldbminfo *li = (struct ldbminfo *)arg;
-
-    return (void *)((uintptr_t)li->li_dblayer_private->dblayer_tx_max);
-}
-
-static int
-ldbm_config_db_tx_max_set(
-    void *arg,
-    void *value,
-    char *errorbuf __attribute__((unused)),
-    int phase __attribute__((unused)),
-    int apply)
-{
-    struct ldbminfo *li = (struct ldbminfo *)arg;
-    int retval = LDAP_SUCCESS;
-    int val = (int)((uintptr_t)value);
-
-    if (apply) {
-        li->li_dblayer_private->dblayer_tx_max = val;
-    }
-
-    return retval;
-}
-
-static void *
-ldbm_config_db_deadlock_policy_get(void *arg)
-{
-    struct ldbminfo *li = (struct ldbminfo *)arg;
-
-    return (void *)((uintptr_t)li->li_dblayer_private->dblayer_deadlock_policy);
-}
-
-static int
-ldbm_config_db_deadlock_policy_set(void *arg,
-                                   void *value,
-                                   char *errorbuf,
-                                   int phase __attribute__((unused)),
-                                   int apply)
-{
-    struct ldbminfo *li = (struct ldbminfo *)arg;
-    int retval = LDAP_SUCCESS;
-    u_int32_t val = (u_int32_t)((uintptr_t)value);
-
-    if (val > DB_LOCK_YOUNGEST) {
-        slapi_create_errormsg(errorbuf, SLAPI_DSE_RETURNTEXT_SIZE,
-                              "Error: Invalid value for %s (%d). Must be between %d and %d inclusive",
-                              CONFIG_DB_DEADLOCK_POLICY, val, DB_LOCK_DEFAULT, DB_LOCK_YOUNGEST);
-        slapi_log_err(SLAPI_LOG_ERR, "ldbm_config_db_deadlock_policy_set",
-                      "Invalid value for deadlock policy (%d). Must be between %d and %d inclusive",
-                      val, DB_LOCK_DEFAULT, DB_LOCK_YOUNGEST);
-        return LDAP_UNWILLING_TO_PERFORM;
-    }
-    if (val == DB_LOCK_NORUN) {
-        slapi_create_errormsg(errorbuf, SLAPI_DSE_RETURNTEXT_SIZE,
-                              "Warning: Setting value for %s to (%d) will disable deadlock detection",
-                              CONFIG_DB_DEADLOCK_POLICY, val);
-        slapi_log_err(SLAPI_LOG_WARNING, "ldbm_config_db_deadlock_policy_set",
-                      "Setting value for %s to (%d) will disable deadlock detection",
-                      CONFIG_DB_DEADLOCK_POLICY, val);
-    }
-
-    if (apply) {
-        li->li_dblayer_private->dblayer_deadlock_policy = val;
-    }
-
-    return retval;
-}
-
 
 /*------------------------------------------------------------------------
  * Configuration array for ldbm and dblayer variables
@@ -1824,50 +1059,18 @@ static config_info ldbm_config[] = {
     {CONFIG_MAXPASSBEFOREMERGE, CONFIG_TYPE_INT, "100", &ldbm_config_maxpassbeforemerge_get, &ldbm_config_maxpassbeforemerge_set, 0},
 
     /* dblayer config attributes */
-    {CONFIG_DB_LOGDIRECTORY, CONFIG_TYPE_STRING, "", &ldbm_config_db_logdirectory_get, &ldbm_config_db_logdirectory_set, CONFIG_FLAG_ALWAYS_SHOW},
-    {CONFIG_DB_DURABLE_TRANSACTIONS, CONFIG_TYPE_ONOFF, "on", &ldbm_config_db_durable_transactions_get, &ldbm_config_db_durable_transactions_set, CONFIG_FLAG_ALWAYS_SHOW},
-    {CONFIG_DB_CIRCULAR_LOGGING, CONFIG_TYPE_ONOFF, "on", &ldbm_config_db_circular_logging_get, &ldbm_config_db_circular_logging_set, 0},
     {CONFIG_DB_TRANSACTION_LOGGING, CONFIG_TYPE_ONOFF, "on", &ldbm_config_db_transaction_logging_get, &ldbm_config_db_transaction_logging_set, 0},
-    {CONFIG_DB_TRANSACTION_WAIT, CONFIG_TYPE_ONOFF, "off", &ldbm_config_db_transaction_wait_get, &ldbm_config_db_transaction_wait_set, CONFIG_FLAG_ALWAYS_SHOW | CONFIG_FLAG_ALLOW_RUNNING_CHANGE},
-    {CONFIG_DB_CHECKPOINT_INTERVAL, CONFIG_TYPE_INT, "60", &ldbm_config_db_checkpoint_interval_get, &ldbm_config_db_checkpoint_interval_set, CONFIG_FLAG_ALWAYS_SHOW | CONFIG_FLAG_ALLOW_RUNNING_CHANGE},
-    {CONFIG_DB_COMPACTDB_INTERVAL, CONFIG_TYPE_INT, "2592000" /*30days*/, &ldbm_config_db_compactdb_interval_get, &ldbm_config_db_compactdb_interval_set, CONFIG_FLAG_ALWAYS_SHOW | CONFIG_FLAG_ALLOW_RUNNING_CHANGE},
-    {CONFIG_DB_TRANSACTION_BATCH, CONFIG_TYPE_INT, "0", &dblayer_get_batch_transactions, &dblayer_set_batch_transactions, CONFIG_FLAG_ALWAYS_SHOW | CONFIG_FLAG_ALLOW_RUNNING_CHANGE},
-    {CONFIG_DB_TRANSACTION_BATCH_MIN_SLEEP, CONFIG_TYPE_INT, "50", &dblayer_get_batch_txn_min_sleep, &dblayer_set_batch_txn_min_sleep, CONFIG_FLAG_ALWAYS_SHOW | CONFIG_FLAG_ALLOW_RUNNING_CHANGE},
-    {CONFIG_DB_TRANSACTION_BATCH_MAX_SLEEP, CONFIG_TYPE_INT, "50", &dblayer_get_batch_txn_max_sleep, &dblayer_set_batch_txn_max_sleep, CONFIG_FLAG_ALWAYS_SHOW | CONFIG_FLAG_ALLOW_RUNNING_CHANGE},
-    {CONFIG_DB_LOGBUF_SIZE, CONFIG_TYPE_SIZE_T, "0", &ldbm_config_db_logbuf_size_get, &ldbm_config_db_logbuf_size_set, CONFIG_FLAG_ALWAYS_SHOW},
-    {CONFIG_DB_PAGE_SIZE, CONFIG_TYPE_SIZE_T, "0", &ldbm_config_db_page_size_get, &ldbm_config_db_page_size_set, 0},
-    {CONFIG_DB_INDEX_PAGE_SIZE, CONFIG_TYPE_SIZE_T, "0", &ldbm_config_db_index_page_size_get, &ldbm_config_db_index_page_size_set, 0},
     {CONFIG_DB_IDL_DIVISOR, CONFIG_TYPE_INT, "0", &ldbm_config_db_idl_divisor_get, &ldbm_config_db_idl_divisor_set, 0},
     {CONFIG_DB_OLD_IDL_MAXIDS, CONFIG_TYPE_INT, "0", &ldbm_config_db_old_idl_maxids_get, &ldbm_config_db_old_idl_maxids_set, 0},
-    {CONFIG_DB_LOGFILE_SIZE, CONFIG_TYPE_UINT64, "0", &ldbm_config_db_logfile_size_get, &ldbm_config_db_logfile_size_set, 0},
-    {CONFIG_DB_TRICKLE_PERCENTAGE, CONFIG_TYPE_INT, "5", &ldbm_config_db_trickle_percentage_get, &ldbm_config_db_trickle_percentage_set, 0},
-    {CONFIG_DB_SPIN_COUNT, CONFIG_TYPE_INT, "0", &ldbm_config_db_spin_count_get, &ldbm_config_db_spin_count_set, 0},
     {CONFIG_DB_VERBOSE, CONFIG_TYPE_ONOFF, "off", &ldbm_config_db_verbose_get, &ldbm_config_db_verbose_set, 0},
     {CONFIG_DB_DEBUG, CONFIG_TYPE_ONOFF, "on", &ldbm_config_db_debug_get, &ldbm_config_db_debug_set, 0},
-    {CONFIG_DB_NAMED_REGIONS, CONFIG_TYPE_ONOFF, "off", &ldbm_config_db_named_regions_get, &ldbm_config_db_named_regions_set, 0},
-    {CONFIG_DB_LOCK, CONFIG_TYPE_INT, "10000", &ldbm_config_db_lock_get, &ldbm_config_db_lock_set, CONFIG_FLAG_ALWAYS_SHOW | CONFIG_FLAG_ALLOW_RUNNING_CHANGE},
-    {CONFIG_DB_PRIVATE_MEM, CONFIG_TYPE_ONOFF, "off", &ldbm_config_db_private_mem_get, &ldbm_config_db_private_mem_set, 0},
-    {CONFIG_DB_PRIVATE_IMPORT_MEM, CONFIG_TYPE_ONOFF, "on", &ldbm_config_db_private_import_mem_get, &ldbm_config_db_private_import_mem_set, CONFIG_FLAG_ALWAYS_SHOW | CONFIG_FLAG_ALLOW_RUNNING_CHANGE},
     {CONDIF_DB_ONLINE_IMPORT_ENCRYPT, CONFIG_TYPE_ONOFF, "on", &ldbm_config_db_online_import_encrypt_get, &ldbm_config_db_online_import_encrypt_set, 0},
-    {CONFIG_DB_SHM_KEY, CONFIG_TYPE_LONG, "389389", &ldbm_config_db_shm_key_get, &ldbm_config_db_shm_key_set, 0},
-    {CONFIG_DB_CACHE, CONFIG_TYPE_INT, "0", &ldbm_config_db_cache_get, &ldbm_config_db_cache_set, 0},
-    {CONFIG_DB_DEBUG_CHECKPOINTING, CONFIG_TYPE_ONOFF, "off", &ldbm_config_db_debug_checkpointing_get, &ldbm_config_db_debug_checkpointing_set, 0},
-    {CONFIG_DB_HOME_DIRECTORY, CONFIG_TYPE_STRING, "", &ldbm_config_db_home_directory_get, &ldbm_config_db_home_directory_set, 0},
-    {CONFIG_IMPORT_CACHE_AUTOSIZE, CONFIG_TYPE_INT, "-1", &ldbm_config_import_cache_autosize_get, &ldbm_config_import_cache_autosize_set, CONFIG_FLAG_ALWAYS_SHOW | CONFIG_FLAG_ALLOW_RUNNING_CHANGE},
-    {CONFIG_CACHE_AUTOSIZE, CONFIG_TYPE_INT, "10", &ldbm_config_cache_autosize_get, &ldbm_config_cache_autosize_set, CONFIG_FLAG_ALWAYS_SHOW | CONFIG_FLAG_ALLOW_RUNNING_CHANGE},
-    {CONFIG_CACHE_AUTOSIZE_SPLIT, CONFIG_TYPE_INT, "25", &ldbm_config_cache_autosize_split_get, &ldbm_config_cache_autosize_split_set, CONFIG_FLAG_ALWAYS_SHOW | CONFIG_FLAG_ALLOW_RUNNING_CHANGE},
     {CONFIG_IMPORT_CACHESIZE, CONFIG_TYPE_UINT64, "16777216", &ldbm_config_import_cachesize_get, &ldbm_config_import_cachesize_set, CONFIG_FLAG_ALWAYS_SHOW | CONFIG_FLAG_ALLOW_RUNNING_CHANGE},
     {CONFIG_IDL_SWITCH, CONFIG_TYPE_STRING, "new", &ldbm_config_idl_get_idl_new, &ldbm_config_idl_set_tune, CONFIG_FLAG_ALWAYS_SHOW},
     {CONFIG_IDL_UPDATE, CONFIG_TYPE_ONOFF, "on", &ldbm_config_idl_get_update, &ldbm_config_idl_set_update, 0},
     {CONFIG_BYPASS_FILTER_TEST, CONFIG_TYPE_STRING, "on", &ldbm_config_get_bypass_filter_test, &ldbm_config_set_bypass_filter_test, CONFIG_FLAG_ALWAYS_SHOW | CONFIG_FLAG_ALLOW_RUNNING_CHANGE},
     {CONFIG_USE_VLV_INDEX, CONFIG_TYPE_ONOFF, "on", &ldbm_config_get_use_vlv_index, &ldbm_config_set_use_vlv_index, CONFIG_FLAG_ALWAYS_SHOW | CONFIG_FLAG_ALLOW_RUNNING_CHANGE},
-    {CONFIG_DB_LOCKDOWN, CONFIG_TYPE_ONOFF, "off", &ldbm_config_db_lockdown_get, &ldbm_config_db_lockdown_set, 0},
-    {CONFIG_INDEX_BUFFER_SIZE, CONFIG_TYPE_INT, "0", &ldbm_config_index_buffer_size_get, &ldbm_config_index_buffer_size_set, 0},
-    {CONFIG_EXCLUDE_FROM_EXPORT, CONFIG_TYPE_STRING,
-     CONFIG_EXCLUDE_FROM_EXPORT_DEFAULT_VALUE,
-     &ldbm_config_exclude_from_export_get,
-     &ldbm_config_exclude_from_export_set, CONFIG_FLAG_ALWAYS_SHOW},
-    {CONFIG_DB_TX_MAX, CONFIG_TYPE_INT, "200", &ldbm_config_db_tx_max_get, &ldbm_config_db_tx_max_set, 0},
+    {CONFIG_EXCLUDE_FROM_EXPORT, CONFIG_TYPE_STRING, CONFIG_EXCLUDE_FROM_EXPORT_DEFAULT_VALUE, &ldbm_config_exclude_from_export_get, &ldbm_config_exclude_from_export_set, CONFIG_FLAG_ALWAYS_SHOW},
     {CONFIG_SERIAL_LOCK, CONFIG_TYPE_ONOFF, "on", &ldbm_config_serial_lock_get, &ldbm_config_serial_lock_set, CONFIG_FLAG_ALWAYS_SHOW | CONFIG_FLAG_ALLOW_RUNNING_CHANGE},
     {CONFIG_USE_LEGACY_ERRORCODE, CONFIG_TYPE_ONOFF, "off", &ldbm_config_legacy_errcode_get, &ldbm_config_legacy_errcode_set, 0},
     {CONFIG_ENTRYRDN_SWITCH, CONFIG_TYPE_ONOFF, "on", &ldbm_config_entryrdn_switch_get, &ldbm_config_entryrdn_switch_set, CONFIG_FLAG_ALWAYS_SHOW},
@@ -1876,7 +1079,7 @@ static config_info ldbm_config[] = {
     {CONFIG_PAGEDIDLISTSCANLIMIT, CONFIG_TYPE_INT, "0", &ldbm_config_pagedallidsthreshold_get, &ldbm_config_pagedallidsthreshold_set, CONFIG_FLAG_ALWAYS_SHOW | CONFIG_FLAG_ALLOW_RUNNING_CHANGE},
     {CONFIG_RANGELOOKTHROUGHLIMIT, CONFIG_TYPE_INT, "5000", &ldbm_config_rangelookthroughlimit_get, &ldbm_config_rangelookthroughlimit_set, CONFIG_FLAG_ALWAYS_SHOW | CONFIG_FLAG_ALLOW_RUNNING_CHANGE},
     {CONFIG_BACKEND_OPT_LEVEL, CONFIG_TYPE_INT, "1", &ldbm_config_backend_opt_level_get, &ldbm_config_backend_opt_level_set, CONFIG_FLAG_ALWAYS_SHOW},
-    {CONFIG_DB_DEADLOCK_POLICY, CONFIG_TYPE_INT, STRINGIFYDEFINE(DB_LOCK_YOUNGEST), &ldbm_config_db_deadlock_policy_get, &ldbm_config_db_deadlock_policy_set, CONFIG_FLAG_ALWAYS_SHOW | CONFIG_FLAG_ALLOW_RUNNING_CHANGE},
+    {CONFIG_BACKEND_IMPLEMENT, CONFIG_TYPE_STRING, "bdb", &ldbm_config_backend_implement_get, &ldbm_config_backend_implement_set, CONFIG_FLAG_ALWAYS_SHOW},
     {NULL, 0, NULL, NULL, NULL, 0}};
 
 void
@@ -2006,16 +1209,6 @@ ldbm_config_load_dse_info(struct ldbminfo *li)
         slapi_pblock_destroy(search_pb);
     }
 
-    /* Find all the instance entries and create a Slapi_Backend and an
-     * ldbm_instance for each */
-    rval = ldbm_config_read_instance_entries(li, li->li_plugin->plg_name);
-    if (rval) {
-        slapi_log_err(SLAPI_LOG_ERR,
-                      "ldbm_config_load_dse_info",
-                      "failed to read instance entries\n");
-        goto bail;
-    }
-
     /* setup the dse callback functions for the ldbm backend config entry */
     slapi_config_register_callback(SLAPI_OPERATION_SEARCH, DSE_FLAG_PREOP, dn,
                                    LDAP_SCOPE_BASE, "(objectclass=*)", ldbm_config_search_entry_callback,
@@ -2072,18 +1265,6 @@ ldbm_config_load_dse_info(struct ldbminfo *li)
         rval = 1;
         goto bail;
     }
-    slapi_config_register_callback(SLAPI_OPERATION_ADD, DSE_FLAG_PREOP, dn,
-                                   LDAP_SCOPE_SUBTREE, "(objectclass=nsBackendInstance)",
-                                   ldbm_instance_add_instance_entry_callback, (void *)li);
-    slapi_config_register_callback(SLAPI_OPERATION_ADD, DSE_FLAG_POSTOP, dn,
-                                   LDAP_SCOPE_SUBTREE, "(objectclass=nsBackendInstance)",
-                                   ldbm_instance_postadd_instance_entry_callback, (void *)li);
-    slapi_config_register_callback(SLAPI_OPERATION_DELETE, DSE_FLAG_PREOP, dn,
-                                   LDAP_SCOPE_SUBTREE, "(objectclass=nsBackendInstance)",
-                                   ldbm_instance_delete_instance_entry_callback, (void *)li);
-    slapi_config_register_callback(SLAPI_OPERATION_DELETE, DSE_FLAG_POSTOP, dn,
-                                   LDAP_SCOPE_SUBTREE, "(objectclass=nsBackendInstance)",
-                                   ldbm_instance_post_delete_instance_entry_callback, (void *)li);
 bail:
     slapi_ch_free_string(&dn);
     return rval;
@@ -2542,6 +1723,9 @@ ldbm_config_modify_entry_callback(Slapi_PBlock *pb, Slapi_Entry *entryBefore, Sl
                                  returntext,
                                  ((li->li_flags & LI_FORCE_MOD_CONFIG) ? CONFIG_PHASE_INTERNAL : CONFIG_PHASE_RUNNING),
                                  apply_mod, mods[i]->mod_op);
+            if (rc) {
+                slapi_log_err(SLAPI_LOG_ERR, "ldbm_config_modify_entry_callback", "Modifying config attribute %s failed (err=%d)\n", attr_name, rc);
+            }
             if (apply_mod) {
                 mod_free(mods[i]);
                 mods[i] = NULL;
@@ -2616,6 +1800,7 @@ ldbm_config_destroy(struct ldbminfo *li)
     }
     slapi_ch_free((void **)&(li->li_new_directory));
     slapi_ch_free((void **)&(li->li_directory));
+    slapi_ch_free((void **)&(li->li_backend_implement));
     /* Destroy the mutexes and cond var */
     PR_DestroyLock(li->li_dbcache_mutex);
     PR_DestroyLock(li->li_shutdown_mutex);
diff --git a/ldap/servers/slapd/back-ldbm/ldbm_config.h b/ldap/servers/slapd/back-ldbm/ldbm_config.h
index 29fb7a779..c7d8fd2c1 100644
--- a/ldap/servers/slapd/back-ldbm/ldbm_config.h
+++ b/ldap/servers/slapd/back-ldbm/ldbm_config.h
@@ -53,6 +53,7 @@ struct config_info
     int config_flags;
 };
 
+#define CONFIG_BACKEND_IMPLEMENT "nsslapd-backend-implement"
 #define CONFIG_INSTANCE "nsslapd-instance"
 #define CONFIG_LOOKTHROUGHLIMIT "nsslapd-lookthroughlimit"
 #define CONFIG_RANGELOOKTHROUGHLIMIT "nsslapd-rangelookthroughlimit"
diff --git a/ldap/servers/slapd/back-ldbm/ldbm_index_config.c b/ldap/servers/slapd/back-ldbm/ldbm_index_config.c
index 95e76c8dc..35c75edae 100644
--- a/ldap/servers/slapd/back-ldbm/ldbm_index_config.c
+++ b/ldap/servers/slapd/back-ldbm/ldbm_index_config.c
@@ -185,7 +185,7 @@ ldbm_instance_index_config_delete_callback(Slapi_PBlock *pb,
         *returncode = LDAP_UNAVAILABLE;
         rc = SLAPI_DSE_CALLBACK_ERROR;
     } else {
-        if (dblayer_erase_index_file(inst->inst_be, ainfo, 0 /* do chkpt */)) {
+        if (dblayer_erase_index_file(inst->inst_be, ainfo, PR_TRUE, 0 /* do chkpt */)) {
             *returncode = LDAP_UNWILLING_TO_PERFORM;
             rc = SLAPI_DSE_CALLBACK_ERROR;
         }
diff --git a/ldap/servers/slapd/back-ldbm/ldbm_instance_config.c b/ldap/servers/slapd/back-ldbm/ldbm_instance_config.c
index 5eac1c1df..593668d51 100644
--- a/ldap/servers/slapd/back-ldbm/ldbm_instance_config.c
+++ b/ldap/servers/slapd/back-ldbm/ldbm_instance_config.c
@@ -809,27 +809,6 @@ ldbm_instance_search_config_entry_callback(Slapi_PBlock *pb __attribute__((unuse
     return SLAPI_DSE_CALLBACK_OK;
 }
 
-/* This function is used by the instance modify callback to add a new
- * suffix.  It return LDAP_SUCCESS on success.
- */
-int
-add_suffix(ldbm_instance *inst, struct berval **bvals, int apply_mod, char *returntext)
-{
-    Slapi_DN suffix;
-    int x;
-
-    returntext[0] = '\0';
-    for (x = 0; bvals[x]; x++) {
-        slapi_sdn_init_dn_byref(&suffix, bvals[x]->bv_val);
-        if (!slapi_be_issuffix(inst->inst_be, &suffix) && apply_mod) {
-            be_addsuffix(inst->inst_be, &suffix);
-        }
-        slapi_sdn_done(&suffix);
-    }
-
-    return LDAP_SUCCESS;
-}
-
 /*
  * Config. DSE callback for instance entry modifies.
  */
@@ -1080,108 +1059,6 @@ ldbm_instance_add_instance_entry_callback(Slapi_PBlock *pb,
 }
 
 
-/* unregister the DSE callbacks on a backend -- this needs to be done when
- * deleting a backend, so that adding the same backend later won't cause
- * these expired callbacks to be called.
- */
-static void
-ldbm_instance_unregister_callbacks(ldbm_instance *inst)
-{
-    struct ldbminfo *li = inst->inst_li;
-    char *dn = NULL;
-
-    /* tear down callbacks for the instance config entry */
-    dn = slapi_create_dn_string("cn=%s,cn=%s,cn=plugins,cn=config",
-                                inst->inst_name, li->li_plugin->plg_name);
-    if (NULL == dn) {
-        slapi_log_err(SLAPI_LOG_ERR,
-                      "ldbm_instance_unregister_callbacks",
-                      "Failed create instance dn for plugin %s, "
-                      "instance %s\n",
-                      inst->inst_li->li_plugin->plg_name, inst->inst_name);
-        goto bail;
-    }
-    slapi_config_remove_callback(SLAPI_OPERATION_SEARCH, DSE_FLAG_PREOP, dn,
-                                 LDAP_SCOPE_BASE, "(objectclass=*)",
-                                 ldbm_instance_search_config_entry_callback);
-    slapi_config_remove_callback(SLAPI_OPERATION_MODIFY, DSE_FLAG_PREOP, dn,
-                                 LDAP_SCOPE_BASE, "(objectclass=*)",
-                                 ldbm_instance_modify_config_entry_callback);
-    slapi_config_remove_callback(DSE_OPERATION_WRITE, DSE_FLAG_PREOP, dn,
-                                 LDAP_SCOPE_BASE, "(objectclass=*)",
-                                 ldbm_instance_search_config_entry_callback);
-    slapi_config_remove_callback(SLAPI_OPERATION_ADD, DSE_FLAG_PREOP, dn,
-                                 LDAP_SCOPE_BASE, "(objectclass=*)",
-                                 ldbm_instance_deny_config);
-    slapi_ch_free_string(&dn);
-
-    /* now the cn=monitor entry */
-    dn = slapi_create_dn_string("cn=monitor,cn=%s,cn=%s,cn=plugins,cn=config",
-                                inst->inst_name, li->li_plugin->plg_name);
-    if (NULL == dn) {
-        slapi_log_err(SLAPI_LOG_ERR,
-                      "ldbm_instance_unregister_callbacks",
-                      "Failed create monitor instance dn for plugin %s, "
-                      "instance %s\n",
-                      inst->inst_li->li_plugin->plg_name, inst->inst_name);
-        goto bail;
-    }
-    slapi_config_remove_callback(SLAPI_OPERATION_SEARCH, DSE_FLAG_PREOP, dn,
-                                 LDAP_SCOPE_BASE, "(objectclass=*)", ldbm_back_monitor_instance_search);
-    slapi_config_remove_callback(SLAPI_OPERATION_ADD, DSE_FLAG_PREOP, dn,
-                                 LDAP_SCOPE_SUBTREE, "(objectclass=*)", ldbm_instance_deny_config);
-    slapi_config_remove_callback(SLAPI_OPERATION_MODIFY, DSE_FLAG_PREOP, dn,
-                                 LDAP_SCOPE_BASE, "(objectclass=*)", ldbm_instance_deny_config);
-    slapi_ch_free_string(&dn);
-
-    /* now the cn=index entries */
-    dn = slapi_create_dn_string("cn=index,cn=%s,cn=%s,cn=plugins,cn=config",
-                                inst->inst_name, li->li_plugin->plg_name);
-    if (NULL == dn) {
-        slapi_log_err(SLAPI_LOG_ERR,
-                      "ldbm_instance_unregister_callbacks",
-                      "Failed create index dn for plugin %s, "
-                      "instance %s\n",
-                      inst->inst_li->li_plugin->plg_name, inst->inst_name);
-        goto bail;
-    }
-    slapi_config_remove_callback(SLAPI_OPERATION_ADD, DSE_FLAG_PREOP, dn,
-                                 LDAP_SCOPE_SUBTREE, "(objectclass=nsIndex)",
-                                 ldbm_instance_index_config_add_callback);
-    slapi_config_remove_callback(SLAPI_OPERATION_DELETE, DSE_FLAG_PREOP, dn,
-                                 LDAP_SCOPE_SUBTREE, "(objectclass=nsIndex)",
-                                 ldbm_instance_index_config_delete_callback);
-    slapi_config_remove_callback(SLAPI_OPERATION_MODIFY, DSE_FLAG_PREOP, dn,
-                                 LDAP_SCOPE_SUBTREE, "(objectclass=nsIndex)",
-                                 ldbm_instance_index_config_modify_callback);
-    slapi_ch_free_string(&dn);
-
-    /* now the cn=encrypted attributes entries */
-    dn = slapi_create_dn_string("cn=encrypted attributes,cn=%s,cn=%s,cn=plugins,cn=config",
-                                inst->inst_name, li->li_plugin->plg_name);
-    if (NULL == dn) {
-        slapi_log_err(SLAPI_LOG_ERR,
-                      "ldbm_instance_unregister_callbacks",
-                      "failed create encrypted attributes dn for plugin %s, "
-                      "instance %s\n",
-                      inst->inst_li->li_plugin->plg_name, inst->inst_name);
-        goto bail;
-    }
-    slapi_config_remove_callback(SLAPI_OPERATION_ADD, DSE_FLAG_PREOP, dn,
-                                 LDAP_SCOPE_SUBTREE, ldbm_instance_attrcrypt_filter,
-                                 ldbm_instance_attrcrypt_config_add_callback);
-    slapi_config_remove_callback(SLAPI_OPERATION_DELETE, DSE_FLAG_PREOP, dn,
-                                 LDAP_SCOPE_SUBTREE, ldbm_instance_attrcrypt_filter,
-                                 ldbm_instance_attrcrypt_config_delete_callback);
-    slapi_config_remove_callback(SLAPI_OPERATION_MODIFY, DSE_FLAG_PREOP, dn,
-                                 LDAP_SCOPE_SUBTREE, ldbm_instance_attrcrypt_filter,
-                                 ldbm_instance_attrcrypt_config_modify_callback);
-
-    vlv_remove_callbacks(inst);
-bail:
-    slapi_ch_free_string(&dn);
-}
-
 
 int
 ldbm_instance_post_delete_instance_entry_callback(Slapi_PBlock *pb __attribute__((unused)),
@@ -1191,111 +1068,6 @@ ldbm_instance_post_delete_instance_entry_callback(Slapi_PBlock *pb __attribute__
                                                   char *returntext,
                                                   void *arg)
 {
-    char *instance_name;
-    struct ldbminfo *li = (struct ldbminfo *)arg;
-    struct ldbm_instance *inst = NULL;
-
-    parse_ldbm_instance_entry(entryBefore, &instance_name);
-    inst = ldbm_instance_find_by_name(li, instance_name);
-
-    if (inst == NULL) {
-        slapi_log_err(SLAPI_LOG_ERR, "ldbm_instance_post_delete_instance_entry_callback",
-                      "Instance '%s' does not exist!\n", instance_name);
-        if (returntext) {
-            PR_snprintf(returntext, SLAPI_DSE_RETURNTEXT_SIZE, "No ldbm instance exists with the name '%s'\n",
-                        instance_name);
-        }
-        if (returncode) {
-            *returncode = LDAP_UNWILLING_TO_PERFORM;
-        }
-        slapi_ch_free((void **)&instance_name);
-        return SLAPI_DSE_CALLBACK_ERROR;
-    }
-
-    slapi_log_err(SLAPI_LOG_INFO, "ldbm_instance_post_delete_instance_entry_callback",
-                  "Removing '%s'.\n", instance_name);
-
-    cache_destroy_please(&inst->inst_cache, CACHE_TYPE_ENTRY);
-    if (entryrdn_get_switch()) { /* subtree-rename: on */
-        cache_destroy_please(&inst->inst_dncache, CACHE_TYPE_DN);
-    }
-    {
-        struct ldbminfo *li = (struct ldbminfo *)inst->inst_be->be_database->plg_private;
-        dblayer_private *priv = (dblayer_private *)li->li_dblayer_private;
-        struct dblayer_private_env *pEnv = priv->dblayer_env;
-        if (pEnv) {
-            PRDir *dirhandle = NULL;
-            char inst_dir[MAXPATHLEN * 2];
-            char *inst_dirp = NULL;
-
-            if (inst->inst_dir_name == NULL) {
-                dblayer_get_instance_data_dir(inst->inst_be);
-            }
-            inst_dirp = dblayer_get_full_inst_dir(li, inst,
-                                                  inst_dir, MAXPATHLEN * 2);
-            if (NULL != inst_dirp) {
-                dirhandle = PR_OpenDir(inst_dirp);
-                /* the db dir instance may have been removed already */
-                if (dirhandle) {
-                    PRDirEntry *direntry = NULL;
-                    char *dbp = NULL;
-                    char *p = NULL;
-                    while (NULL != (direntry = PR_ReadDir(dirhandle,
-                                                          PR_SKIP_DOT | PR_SKIP_DOT_DOT))) {
-                        int rc;
-                        if (!direntry->name)
-                            break;
-
-                        dbp = PR_smprintf("%s/%s", inst_dirp, direntry->name);
-                        if (NULL == dbp) {
-                            slapi_log_err(SLAPI_LOG_ERR,
-                                          "ldbm_instance_post_delete_instance_entry_callback",
-                                          "Failed to generate db path: %s/%s\n",
-                                          inst_dirp, direntry->name);
-                            break;
-                        }
-
-                        p = strstr(dbp, LDBM_FILENAME_SUFFIX);
-                        if (NULL != p &&
-                            strlen(p) == strlen(LDBM_FILENAME_SUFFIX)) {
-                            rc = dblayer_db_remove(pEnv, dbp, 0);
-                        } else {
-                            rc = PR_Delete(dbp);
-                        }
-                        PR_ASSERT(rc == 0);
-                        if (rc != 0) {
-                            slapi_log_err(SLAPI_LOG_ERR,
-                                          "ldbm_instance_post_delete_instance_entry_callback",
-                                          "Failed to delete %s, error %d\n", dbp, rc);
-                        }
-                        PR_smprintf_free(dbp);
-                    }
-                    PR_CloseDir(dirhandle);
-                }
-                /*
-                 * When a backend was removed, the db instance directory
-                 * was removed as well (See also bz463774).
-                 * In case DB_RECOVER_FATAL is set in the DB open after
-                 * the removal (e.g., in restore), the logs in the transaction
-                 * logs are replayed and compared with the contents of the DB
-                 * files.  At that time, if the db instance directory does not
-                 * exist, libdb returns FATAL error.  To prevent the problem,
-                 * we have to leave the empty directory. (bz597375)
-                 *
-                 * PR_RmDir(inst_dirp);
-                 */
-            } /* non-null dirhandle */
-            if (inst_dirp != inst_dir) {
-                slapi_ch_free_string(&inst_dirp);
-            }
-        } /* non-null pEnv */
-    }
-
-    ldbm_instance_unregister_callbacks(inst);
-    slapi_be_free(&inst->inst_be);
-    ldbm_instance_destroy(inst);
-    slapi_ch_free((void **)&instance_name);
-
     return SLAPI_DSE_CALLBACK_OK;
 }
 
